//---------------------------------------------------------------------------
//
//   PutObjects
//
//          Copyright(C) 2011 Claybird
//          Under New BSD License
//
//
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "MQPlugin.h"

BOOL PutObjects(MQDocument doc);


//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0xB3A8500C;
	*ID      = 0x3C608912;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "PutObjects Ver.0.02       Copyright(C) 2011, Claybird";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// IuWFNgό`pvOCł
	return MQPLUGIN_TYPE_OBJECT;
}

//---------------------------------------------------------------------------
//  MQEnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumString(int index)
{
	switch(index){
	case 0: return "I_ɌIuWFNgzu";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQModifyObject
//    j[IꂽƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQModifyObject(int index, MQDocument doc)
{
	switch(index){
	case 0: return PutObjects(doc);
	}
	return FALSE;
}

//I_Ɍ݂̃IuWFNgzu
BOOL PutObjects(MQDocument doc)
{
	int srcObjIdx=doc->GetCurrentObjectIndex();
	if(srcObjIdx==-1)return FALSE;
	MQObject srcObj=doc->GetObject(srcObjIdx);
	if(!srcObj)return FALSE;

	MQObject newObj=MQ_CreateObject();

	int numObjs=doc->GetObjectCount();
	for(int objIdx=0;objIdx<numObjs;objIdx++){
		MQObject obj=doc->GetObject(objIdx);
		int numVertices=obj->GetVertexCount();
		for(int iVert=0;iVert<numVertices;iVert++){
			//I_o
			if(doc->IsSelectVertex(objIdx,iVert)){
				MQPoint pt=obj->GetVertex(iVert);
				//Wϊă}[W:_SƌȂ
				MQObject tmp=srcObj->Clone();
				int numVertTmp=tmp->GetVertexCount();
				for(int i=0;i<numVertTmp;i++){
					tmp->SetVertex(i,tmp->GetVertex(i)+pt);
				}
				newObj->Merge(tmp);
				tmp->DeleteThis();
			}
		}
	}

	if(newObj->GetVertexCount()==0){
		newObj->DeleteThis();
		return FALSE;
	}else{
		newObj->Compact();
		doc->AddObject(newObj);
		return TRUE;
	}
}
